/*#########################################################################
#                                                                         #
#   ...mostly ripped from Polish Radio script, thanks :)                  #
#                                                                         #
#   CBC Radio web site:                                                   #
#       http://www.cbc.ca/listen/includes/directr1.html                   #
#       http://music.cbc.ca/#/streams.aspx                                #
#                                                                         #
#   prepared by sasha@goldnet.ca                                          #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         #
#                                                                         #
##########################################################################*/

// In Amarok >2.3.x you must have at least 7 items at Level 1 see:
// https://bugs.kde.org/show_bug.cgi?id=259241

Importer.loadQtBinding("qt.core");
Importer.loadQtBinding("qt.gui");

function Station( name, url, description ) {
    this.name = name;
    this.url = url;
    this.description = description;
}

var categories = new Object;

categories["CBC Music: Sonica"]= new Array (
    new Station(
        "Sonica",
        "http://playerservices.streamtheworld.com/pls/CBC_SONICA_H.pls"
    )
);

categories["CBC Radio 1"]= new Array (
    new Station(
        "Alberta - Calgary",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_CGY_H.pls"
    ),
    new Station(
        "Alberta - Edmonton",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_EDM_H.pls"
    ),
    new Station(
        "British Columbia - Kelowna",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_KEL_H.pls"
    ),
    new Station(
        "British Columbia - Prince George",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_PRG_H.pls"
    ),
    new Station(
        "British Columbia - Vancouver",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_VCR_H.pls"
    ),
    new Station(
        "British Columbia - Victoria",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_VIC_H.pls"
    ),
    new Station(
        "Manitoba - Winnipeg",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_WPG_H.pls"
    ),
    new Station(
        "New Brunswick - Fredericton",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_FRD_H.pls"
    ),
    new Station(
        "New Brunswick - Moncton",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_MCT_H.pls"
    ),
    new Station(
        "New Brunswick - Saint John",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_SNB_H.pls"
    ),
    new Station(
        "Newfoundland - Corner Brook",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_COR_H.pls"
    ),
    new Station(
        "Newfoundland - Grand Falls",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_GFA_H.pls"
    ),
    new Station(
        "Newfoundland - Labrador/Goose Bay",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_GBA_H.pls"
    ),
    new Station(
        "Newfoundland - St. John's",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_SNF_H.pls"
    ),
    new Station(
        "Nova Scotia - Halifax",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_HFX_H.pls"
    ),
    new Station(
        "Nova Scotia - Sydney",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_SYD_H.pls"
    ),
    new Station(
        "Ontario - London",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_LDN_H.pls"
    ),
    new Station(
        "Ontario - Ottawa",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_OTT_H.pls"
    ),
    new Station(
        "Ontario - Sudbury",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_SUD_H.pls"
    ),
    new Station(
        "Ontario - Thunder Bay",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_TBA_H.pls"
    ),
    new Station(
        "Ontario - Toronto",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_TOR_H.pls"
    ),
    new Station(
        "Ontario - Windsor",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_WDR_H.pls"
    ),
    new Station(
        "Prince Edward Island - Charlottetown",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_CHR_H.pls"
    ),
    new Station(
        "Quebec - Montreal",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_MTL_H.pls"
    ),
    new Station(
        "Quebec - Quebec City",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_QQU_H.pls"
    ),
    new Station(
        "Saskatchewan - Regina",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_REG_H.pls"
    ),
    new Station(
        "The North - Inuvik",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_INK_H.pls"
    ),
    new Station(
        "The North - Iqaluit",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_IQA_H.pls"
    ),
    new Station(
        "The North - Whitehorse",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_WHS_H.pls"
    ),
    new Station(
        "The North - Yellowknife",
        "http://playerservices.streamtheworld.com/pls/CBC_R1_YKN_H.pls"
    )
);

categories["CBC Radio 2"]= new Array (
    new Station(
        "Atlantic",
        "http://playerservices.streamtheworld.com/pls/CBC_R2_HFX_H.pls"
    ),
    new Station(
        "Eastern",
        "http://playerservices.streamtheworld.com/pls/CBC_R2_TOR_H.pls"
    ),
    new Station(
        "Central",
        "http://playerservices.streamtheworld.com/pls/CBC_R2_WPG_H.pls"
    ),
    new Station(
        "Mountain",
        "http://playerservices.streamtheworld.com/pls/CBC_R2_EDM_H.pls"
    ),
    new Station(
        "Pacific",
        "http://playerservices.streamtheworld.com/pls/CBC_R2_VCR_H.pls"
    ),
    new Station(
        "Eastern (International)",
        "http://playerservices.streamtheworld.com/pls/CBC_R2_IET_H.pls"
    ),
    new Station(
        "Pacific (International)",
        "http://playerservices.streamtheworld.com/pls/CBC_R2_IPT_H.pls"
    )
);

categories["CBC Radio 3"]= new Array (
    new Station(
        "Radio 3",
        "http://playerservices.streamtheworld.com/pls/CBC_R3_WEB.pls"
    )
);

categories["Web Radio - Aboriginal"]= new Array (
    new Station(
        "Aboriginal",
        "http://playerservices.streamtheworld.com/pls/CBC_ABORIG_H.pls"
    )
);

categories["Web Radio - Blues"]= new Array (
    new Station(
        "Colin James’ Blues",
        "http://playerservices.streamtheworld.com/pls/CBC_BLUES1_H.pls"
    ),
    new Station(
        "Blues Classics",
        "http://playerservices.streamtheworld.com/pls/CBC_BLCLAS_H.pls"
    )
);

categories["Web Radio - Classical"]= new Array (
    new Station(
        "Radio 2 Classical",
        "http://playerservices.streamtheworld.com/pls/CBC_R2CLAS_H.pls"
    ),
    new Station(
        "Essential Classics",
        "http://playerservices.streamtheworld.com/pls/CBC_ECLASS_H.pls"
    ),
    new Station(
        "Heppner’s Opera Gems",
        "http://playerservices.streamtheworld.com/pls/CBC_OPERAT_H.pls"
    ),
    new Station(
        "Baroque",
        "http://playerservices.streamtheworld.com/pls/CBC_BAROQU_H.pls"
    ),
    new Station(
        "Modern Masters",
        "http://playerservices.streamtheworld.com/pls/CBC_MODMAS_H.pls"
    ),
    new Station(
        "Orchestral",
        "http://playerservices.streamtheworld.com/pls/CBC_ORCHES_H.pls"
    ),
    new Station(
        "Piano",
        "http://playerservices.streamtheworld.com/pls/CBC_PIANO1_H.pls"
    ),
    new Station(
        "Chamber",
        "http://playerservices.streamtheworld.com/pls/CBC_GGSAMP_H.pls"
    ),
    new Station(
        "Choral",
        "http://playerservices.streamtheworld.com/pls/CBC_CHORAL_H.pls"
    ),
    new Station(
        "Canadian Composers",
        "http://playerservices.streamtheworld.com/pls/CBC_CANCOM_H.pls"
    )
);

categories["Web Radio - Country"]= new Array (
    new Station(
        "Country",
        "http://playerservices.streamtheworld.com/pls/CBC_CONTRY_H.pls"
    ),
    new Station(
        "Alternative Country",
        "http://playerservices.streamtheworld.com/pls/CBC_ALTCRY_H.pls"
    ),
    new Station(
        "Country Classics",
        "http://playerservices.streamtheworld.com/pls/CBC_CLSCRY_H.pls"
    )
);

categories["Web Radio - Electronic"]= new Array (
    new Station(
        "Chill Out",
        "http://playerservices.streamtheworld.com/pls/CBC_CHILL1_H.pls"
    ),
    new Station(
        "Workout Mix",
        "http://playerservices.streamtheworld.com/pls/CBC_WRKOUT_H.pls"
    )
);

categories["Web Radio - Hip-Hop"]= new Array (
    new Station(
        "Hip-Hop",
        "http://playerservices.streamtheworld.com/pls/CBC_HIPHOP_H.pls"
    )
);

categories["Web Radio - Jazz"]= new Array (
    new Station(
        "Radio 2 Jazz",
        "http://playerservices.streamtheworld.com/pls/CBC_R2JAZZ_H.plss"
    ),
    new Station(
        "Jazz Masters",
        "http://playerservices.streamtheworld.com/pls/CBC_JAZMAS_H.pls"
    ),
    new Station(
        "Jazz Songbook",
        "http://playerservices.streamtheworld.com/pls/CBC_JAZSON_H.pls"
    ),
     new Station(
        "Jazz Canada",
        "http://playerservices.streamtheworld.com/pls/CBC_JAZCDN_H.pls"
    ),
    new Station(
        "Smooth Jazz",
        "http://playerservices.streamtheworld.com/pls/CBC_JAZSMO_H.pls"
    )
);

categories["Web Radio - Kids"]= new Array (
    new Station(
        "CBC Kids",
        "http://playerservices.streamtheworld.com/pls/CBC_KIDCBC_H.pls"
    )
);

categories["Web Radio - Limited (Holiday) Play"]= new Array (
    new Station(
        "Classical Holidays",
        "http://playerservices.streamtheworld.com/pls/CBC_SPCIAL_H.pls"
    ),
    new Station(
        "Seasonal Favorites",
        "http://playerservices.streamtheworld.com/pls/CBC_SPCIA2_H.pls"
    )
);

categories["Web Radio - Luminaries"]= new Array (
    new Station(
        "Bachman's Guitarchives",
        "http://playerservices.streamtheworld.com/pls/CBC_GUITAR_H.pls"
    ),
    new Station(
        "Heppner’s Opera Gems",
        "http://playerservices.streamtheworld.com/pls/CBC_OPERAT_H.pls"
    ),
    new Station(
        "Jian’s New Wave",
        "http://playerservices.streamtheworld.com/pls/CBC_NEWWAV_H.pls"
    ),
    new Station(
        "Colin James’ Blues",
        "http://playerservices.streamtheworld.com/pls/CBC_BLUES1_H.pls"
    )
);

categories["Web Radio - Moods"]= new Array (
    new Station(
        "Chill Out",
        "http://playerservices.streamtheworld.com/pls/CBC_CHILL1_H.pls"
    ),
    new Station(
        "Saddest Songs",
        "http://playerservices.streamtheworld.com/pls/CBC_SADSNG_H.pls"
    ),
    new Station(
        "Workout Mix",
        "http://playerservices.streamtheworld.com/pls/CBC_WRKOUT_H.pls"
    )
);

categories["Web Radio - Pop"]= new Array (
    new Station(
        "Saddest Songs",
        "http://playerservices.streamtheworld.com/pls/CBC_SADSNG_H.pls"
    ),
    new Station(
        "Jian’s New Wave",
        "http://playerservices.streamtheworld.com/pls/CBC_NEWWAV_H.pls"
    ),
    new Station(
        "Pop 40",
        "http://playerservices.streamtheworld.com/pls/CBC_POP040_H.pls"
    ),
    new Station(
        "Adult Pop",
        "http://playerservices.streamtheworld.com/pls/CBC_ADLTPO_H.pls"
    ),
    new Station(
        "Jukebox Classics",
        "http://playerservices.streamtheworld.com/pls/CBC_JUKEBO_H.pls"
    ),
    new Station(
        "The 70s",
        "http://playerservices.streamtheworld.com/pls/CBC_70S001_H.pls"
    ),
    new Station(
        "The 80s",
        "http://playerservices.streamtheworld.com/pls/CBC_80S001_H.pls"
    ),
    new Station(
        "The 90s",
        "http://playerservices.streamtheworld.com/pls/CBC_90S001_H.pls"
    ),
    new Station(
        "Hip-Hop",
        "http://playerservices.streamtheworld.com/pls/CBC_HIPHOP_H.pls"
    )
);

categories["Web Radio - R&B / Soul"]= new Array (
    new Station(
        "Classic Soul / R&B",
        "http://playerservices.streamtheworld.com/pls/CBC_SOULCL_H.pls"
    ),
    new Station(
        "R&B / Soul",
        "http://playerservices.streamtheworld.com/pls/CBC_RBSOUL_H.pls"
    )
);

categories["Web Radio - Rock"]= new Array (
    new Station(
        "Adult Alternative",
        "http://playerservices.streamtheworld.com/pls/CBC_ADLTAL_H.pls"
    ),
    new Station(
        "Bachman's Guitarchives",
        "http://playerservices.streamtheworld.com/pls/CBC_GUITAR_H.pls"
    ),
    new Station(
        "Indie",
        "http://playerservices.streamtheworld.com/pls/CBC_INDIE1_H.pls"
    ),
    new Station(
        "Rock",
        "http://playerservices.streamtheworld.com/pls/CBC_ROCK01_H.pls"
    ),
    new Station(
        "Rock Classics",
        "http://playerservices.streamtheworld.com/pls/CBC_ROCKCL_H.pls"
    )
);

categories["Web Radio - Singer-Songwriter"]= new Array (
    new Station(
        "Adult Alternative",
        "http://playerservices.streamtheworld.com/pls/CBC_ADLTAL_H.pls"
    ),
    new Station(
        "Canadian Roots",
        "http://playerservices.streamtheworld.com/pls/CBC_CDNRTS_H.pls"
    ),
    new Station(
        "Canadian Songwriters",
        "http://playerservices.streamtheworld.com/pls/CBC_CANSON_H.pls"
    ),
    new Station(
        "Singer-Songwriter",
        "http://playerservices.streamtheworld.com/pls/CBC_SINSON_H.pls"
    )
);

categories["Web Radio - World"]= new Array (
    new Station(
        "Bollywood",
        "http://playerservices.streamtheworld.com/pls/CBC_BOLYWD_H.pls"
    ),
    new Station(
        "Latin Top 40",
        "http://playerservices.streamtheworld.com/pls/CBC_LATIN1_H.pls"
    ),
    new Station(
        "Raggae",
        "http://playerservices.streamtheworld.com/pls/CBC_REGGAE_H.pls"
    ),
    new Station(
        "World",
        "http://playerservices.streamtheworld.com/pls/CBC_WORLDM_H.pls"
    )
);

/*
images = new Object;
images["CBC Radio 1"] = "cbc1.png";
images["CBC Radio 2"] = "cbc2.png";
images["CBC Radio 3"] = "cbc3.png";
*/

function RadioCBC() {
    ScriptableServiceScript.call( this, "CBC Radio", 2, "CBC Radio streams", "", false );
}

function onCustomize() {
    var currentDir = Amarok.Info.scriptPath() + "/";
    var iconPixmap = new QPixmap(currentDir+"icon.png");
    script.setIcon(iconPixmap);
    script.setEmblem( iconPixmap );
}


function onConfigure() {
    Amarok.alert( "This script does not require any configuration." );
}

function onPopulating( level, callbackData, filter ) {
    //Amarok.alert( "populating level " + level );
	if ( level == 1 ) {
		for( att in categories ) {
			//Amarok.alert ("att: " + att + ", " + categories[att].name);
			//var cover = Amarok.Info.scriptPath() + "/" + images[att];
			var cover = Amarok.Info.scriptPath() + "/icon.png";
            item = Amarok.StreamItem;
			item.level = 1;
			item.callbackData = att;
			item.itemName = att;
			item.playableUrl = "";
			item.infoHtml = "";
			item.coverUrl = cover;
			script.insertItem( item );
		}
		script.donePopulating();
    } else if ( level == 0 ) {
		//add the station streams as leaf nodes
		var stationArray = categories[callbackData];
		for ( i = 0; i < stationArray.length; i++ ) {
			//Amarok.alert ("item: " + i + " is " + stationArray[i].name);
			// no covers for induvidual streams
			//var cover = Amarok.Info.scriptPath() + "/" + images[callbackData];
			item = Amarok.StreamItem;
			item.level = 0;
			item.callbackData = "";
			item.itemName = stationArray[i].name;
			item.playableUrl = stationArray[i].url;
			item.album = callbackData;
			item.infoHtml = stationArray[i].description;
			//item.artist = "Radio Stream";
			//item.coverUrl = cover;
			script.insertItem( item );
		}
		script.donePopulating();
    }
}

Amarok.configured.connect( onConfigure );
script = new RadioCBC();
script.populate.connect( onPopulating );
script.customize.connect( onCustomize );

